Index: de/branches/core5/src/external/bullet/BulletPrecompiledHeaders.h
===================================================================
--- /code/branches/core5/src/external/bullet/BulletPrecompiledHeaders.h	(revision 5873)
+++ 	(revision )
@@ -1,48 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *                    > www.orxonox.net <
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Reto Grieder
- *   Co-authors:
- *      ...
- *
- */
-
-/**
-@file
-@brief
-    Compilation of the most often used header files in the external bullet library
-@details
-    Updated: 19. September 2009
-    Total Files: 105
-*/
-
-///////////////////////////////////////////
-/////          Stable Headers         /////
-///////////////////////////////////////////
-
-#include <bullet/BulletCollision/CollisionShapes/btConvexInternalShape.h> // 37
-#include <bullet/BulletCollision/CollisionDispatch/btCollisionObject.h> // 33
-
-
-// Just in case some header included windows.h
-#undef min
-#undef max
Index: de/branches/core5/src/libraries/tools/ToolsPrecompiledHeaders.h
===================================================================
--- /code/branches/core5/src/libraries/tools/ToolsPrecompiledHeaders.h	(revision 5873)
+++ 	(revision )
@@ -1,70 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *                    > www.orxonox.net <
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Reto Grieder
- *   Co-authors:
- *      ...
- *
- */
-
-/**
-@file
-@brief
-    Compilation of the most often used header files in the tools library
-@details
-    Updated: 19. September 2009
-    Total Files: 11
-*/
-
-#include "OrxonoxConfig.h"
-
-///////////////////////////////////////////
-/////          Stable Headers         /////
-///////////////////////////////////////////
-
-#include <cassert>  // 11
-#include <cstring>  // 11
-#include <fstream>  // 11
-#include <iostream> // 11
-#include <map>      // 11
-#include <set>      // 11
-#include <sstream>  // 11
-#include <string>   // 11
-#include <vector>   // 11
-#include <cmath>    // 10
-#include <deque>    // 10
-#include <list>     // 10
-#include <queue>    // 10
-
-#include <OgreMath.h>        // 10
-#include <OgreVector2.h>     // 10
-#include <OgreVector3.h>     // 10
-#include <OgreVector4.h>     // 10
-#include <OgreQuaternion.h>  // 10
-#include <OgreColourValue.h> // 10
-
-#include "util/Debug.h"      // 9
-
-
-// Just in case some header included windows.h
-#undef min
-#undef max
Index: /code/branches/core5/src/modules/pong/CMakeLists.txt
===================================================================
--- /code/branches/core5/src/modules/pong/CMakeLists.txt	(revision 5873)
+++ /code/branches/core5/src/modules/pong/CMakeLists.txt	(revision 5874)
@@ -1,4 +1,4 @@
 SET_SOURCE_FILES(PONG_SRC_FILES
-#COMPILATION_BEGIN PongCompilation.cc
+COMPILATION_BEGIN PongCompilation.cc
   Pong.cc
   PongAI.cc
@@ -8,5 +8,5 @@
   PongCenterpoint.cc
   PongScore.cc
-#COMPILATION_END
+COMPILATION_END
 )
 
Index: de/branches/core5/src/modules/pong/PongPrecompiledHeaders.h
===================================================================
--- /code/branches/core5/src/modules/pong/PongPrecompiledHeaders.h	(revision 5873)
+++ 	(revision )
@@ -1,58 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *                    > www.orxonox.net <
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Reto Grieder
- *   Co-authors:
- *      ...
- *
- */
-
-/**
-@file
-@brief
-    Compilation of the most often used header files in the pong module
-@details
-    Updated: 19. September 2009
-    Total Files: 7
-*/
-
-#include "OrxonoxConfig.h"
-
-///////////////////////////////////////////
-/////          Stable Headers         /////
-///////////////////////////////////////////
-
-#include "util/OgreForwardRefs.h" // 6
-
-///////////////////////////////////////////
-/////       All Rebuild Headers       /////
-///////////////////////////////////////////
-
-#include "core/BaseObject.h"   // 7
-#include "core/CoreIncludes.h" // 7
-#include "core/Executor.h"     // 6
-#include "network/synchronisable/Synchronisable.h" // 7
-
-
-// Just in case some header included windows.h
-#undef min
-#undef max