Index: trunk/src/lib/graphics/importer/texture_sequence.cc
===================================================================
--- trunk/src/lib/graphics/importer/texture_sequence.cc	(revision 5866)
+++ trunk/src/lib/graphics/importer/texture_sequence.cc	(revision 5885)
@@ -155,5 +155,5 @@
 
 /**
- * moves to the n'th texture which can then be retrieved via the Texture function: this->getTexture()
+ * @brief moves to the n'th texture which can then be retrieved via the Texture function: this->getTexture()
  * @param frameNumber the n-th frame
  */
Index: trunk/src/lib/graphics/text_engine/text_engine.cc
===================================================================
--- trunk/src/lib/graphics/text_engine/text_engine.cc	(revision 5866)
+++ trunk/src/lib/graphics/text_engine/text_engine.cc	(revision 5885)
@@ -64,5 +64,5 @@
 {
   // first remove all the remaining Texts (if any).
-  std::list<BaseObject*>* textList = ClassList::getList(CL_TEXT);
+  const std::list<BaseObject*>* textList = ClassList::getList(CL_TEXT);
   if (textList != NULL)
   {
@@ -71,5 +71,5 @@
   }
   // delete all remaining fonts (There should not be Anything to do here)
-  std::list<BaseObject*>* fontList = ClassList::getList(CL_FONT);
+  const std::list<BaseObject*>* fontList = ClassList::getList(CL_FONT);
   if (fontList != NULL)
   {
@@ -124,5 +124,5 @@
 void TextEngine::debug() const
 {
-  list<BaseObject*>* textList = ClassList::getList(CL_TEXT);
+  const list<BaseObject*>* textList = ClassList::getList(CL_TEXT);
   if (textList != NULL)
   {
@@ -132,5 +132,5 @@
     PRINT(0)("Reference: %p; Text Counts: %d\n", this, textList->size());
 
-    list<BaseObject*>::iterator text;
+    list<BaseObject*>::const_iterator text;
     for ( text = textList->begin(); text != textList->end(); text++)
       dynamic_cast<Text*>(*text)->debug();
Index: trunk/src/lib/lang/class_list.cc
===================================================================
--- trunk/src/lib/lang/class_list.cc	(revision 5866)
+++ trunk/src/lib/lang/class_list.cc	(revision 5885)
@@ -133,5 +133,5 @@
  * @return the List accessed by classID, or NULL if not found
  */
-std::list<BaseObject*>* ClassList::getList(ClassID classID)
+const std::list<BaseObject*>* ClassList::getList(ClassID classID)
 {
   ClassList* fl;
@@ -156,5 +156,5 @@
  * @return the List accessed by classID, or NULL if not found
  */
-std::list<BaseObject*>* ClassList::getList(const char* className)
+const std::list<BaseObject*>* ClassList::getList(const char* className)
 {
   ClassList* fl;
Index: trunk/src/lib/lang/class_list.h
===================================================================
--- trunk/src/lib/lang/class_list.h	(revision 5866)
+++ trunk/src/lib/lang/class_list.h	(revision 5885)
@@ -40,6 +40,6 @@
     static void                           removeFromClassList(BaseObject* objectPointer);
 
-    static std::list<BaseObject*>*        getList(ClassID classID = CL_NULL);// { return (ClassList* fl = ClassList::getClassList(classID) != NULL)? &(fl->objectList) : NULL; };
-    static std::list<BaseObject*>*        getList(const char* className); // { return (ClassList* fl = ClassList::getClassList(className) != NULL)? &(fl->objectList) : NULL;  };
+    static const std::list<BaseObject*>*  getList(ClassID classID = CL_NULL);// { return (ClassList* fl = ClassList::getClassList(classID) != NULL)? &(fl->objectList) : NULL; };
+    static const std::list<BaseObject*>*  getList(const char* className); // { return (ClassList* fl = ClassList::getClassList(className) != NULL)? &(fl->objectList) : NULL;  };
     static const std::list<const char*>*  getClassNames();
     static BaseObject*                    getObject(const char* name, ClassID classID = CL_NULL);
Index: trunk/src/lib/network/network_manager.cc
===================================================================
--- trunk/src/lib/network/network_manager.cc	(revision 5866)
+++ trunk/src/lib/network/network_manager.cc	(revision 5885)
@@ -161,5 +161,5 @@
   if (this->netStreamList != NULL || (this->netStreamList = ClassList::getList(CL_NETWORK_STREAM)) != NULL)
   {
-    std::list<BaseObject*>::iterator stream;
+    std::list<BaseObject*>::const_iterator stream;
     for (stream = this->netStreamList->begin(); stream != this->netStreamList->end(); ++stream)
       static_cast<NetworkStream*>(*stream)->processData();
Index: trunk/src/lib/network/network_manager.h
===================================================================
--- trunk/src/lib/network/network_manager.h	(revision 5866)
+++ trunk/src/lib/network/network_manager.h	(revision 5885)
@@ -41,6 +41,6 @@
 
 private:
-  std::list<BaseObject*>*    netStreamList;            // list with refs to all network streams
-  std::list<BaseObject*>*    syncList;                 // list of synchronizeables
+  const std::list<BaseObject*>*    netStreamList;            // list with refs to all network streams
+  const std::list<BaseObject*>*    syncList;                 // list of synchronizeables
 
 };
Index: trunk/src/lib/shell/shell_command.cc
===================================================================
--- trunk/src/lib/shell/shell_command.cc	(revision 5866)
+++ trunk/src/lib/shell/shell_command.cc	(revision 5885)
@@ -159,5 +159,5 @@
   long classID = CL_NULL;                      //< the classID retrieved from the Class.
   ShellCommandClass* commandClass = NULL;      //< the command class this command applies to.
-  std::list<BaseObject*>* objectList = NULL;   //< the list of Objects stored in classID
+  const std::list<BaseObject*>* objectList = NULL;   //< the list of Objects stored in classID
   BaseObject* objectPointer = NULL;            //< a pointer to th Object to Execute the command on
   bool emptyComplete = false;                  //< if the completion input is empty string. e.g ""
Index: trunk/src/lib/shell/shell_completion.cc
===================================================================
--- trunk/src/lib/shell/shell_completion.cc	(revision 5866)
+++ trunk/src/lib/shell/shell_completion.cc	(revision 5885)
@@ -58,5 +58,5 @@
 
   long classID;                         //< the classID retrieved from the Class.
-  std::list<BaseObject*>* objectList;   //< the list of Objects stored in classID
+  const std::list<BaseObject*>* objectList;   //< the list of Objects stored in classID
   bool emptyComplete = false;           //< if the completion input is empty string. e.g ""
   long completeType = SHELLC_NONE;      //< the Type we'd like to complete.
Index: trunk/src/lib/sound/sound_engine.cc
===================================================================
--- trunk/src/lib/sound/sound_engine.cc	(revision 5866)
+++ trunk/src/lib/sound/sound_engine.cc	(revision 5885)
@@ -137,5 +137,5 @@
   if (this->sourceList != NULL)
   {
-    list<BaseObject*>::iterator source;
+    list<BaseObject*>::const_iterator source;
     for (source = this->sourceList->begin(); source != this->sourceList->end(); source++)
     {
@@ -182,5 +182,5 @@
   if (likely(this->sourceList != NULL))
   {
-    list<BaseObject*>::iterator sourceIT;
+    list<BaseObject*>::const_iterator sourceIT;
     SoundSource* source;
     for (sourceIT = this->sourceList->begin(); sourceIT != this->sourceList->end(); sourceIT++)
Index: trunk/src/lib/sound/sound_engine.h
===================================================================
--- trunk/src/lib/sound/sound_engine.h	(revision 5866)
+++ trunk/src/lib/sound/sound_engine.h	(revision 5885)
@@ -66,15 +66,15 @@
 
   private:
-    static SoundEngine*      singletonRef;             //!< Reference to this class
+    static SoundEngine*            singletonRef;             //!< Reference to this class
 
-    ALCdevice*               device;                   //!< the used audio-device.
-    ALCcontext*              context;                  //!< the context, currently in use.
+    ALCdevice*                     device;                   //!< the used audio-device.
+    ALCcontext*                    context;                  //!< the context, currently in use.
 
-    float                    musicVolume;              //!< the maximum volume of the music in % (0f,1f]
-    float                    effectsVolume;            //!< the maximum volume of sound-effects in % (0f,1f]
-    PNode*                   listener;                 //!< The listener of the Scene
+    float                          musicVolume;              //!< the maximum volume of the music in % (0f,1f]
+    float                          effectsVolume;            //!< the maximum volume of sound-effects in % (0f,1f]
+    PNode*                         listener;                 //!< The listener of the Scene
 
-    std::list<BaseObject*>*  bufferList;               //!< A list of buffers
-    std::list<BaseObject*>*  sourceList;               //!< A list for all the sources in the scene.
+    const std::list<BaseObject*>*  bufferList;               //!< A list of buffers
+    const std::list<BaseObject*>*  sourceList;               //!< A list for all the sources in the scene.
 
 
Index: trunk/src/world_entities/weapons/weapon_manager.cc
===================================================================
--- trunk/src/world_entities/weapons/weapon_manager.cc	(revision 5866)
+++ trunk/src/world_entities/weapons/weapon_manager.cc	(revision 5885)
@@ -110,6 +110,4 @@
   this->crossHairSizeAnim->addKeyFrame(100, .05, ANIM_LINEAR);
   this->crossHairSizeAnim->addKeyFrame(50, .01, ANIM_LINEAR);
-
-  this->targetIterator = NULL;
 }
 
@@ -337,49 +335,4 @@
     }
   }
-}
-
-
-/**
- * Selects an Entity from the NPC-list, and returns the Target
- */
-PNode* WeaponManager::getSomeTarget()
-{
-   if (this->targetIterator == NULL)
-   {
-     std::list<BaseObject*>* npcList = ClassList::getList(CL_NPC);
-     if (npcList != NULL)
-     {
-       this->targetIterator = npcList->begin();
-     }
-     else
-       return NULL;
-   }
-
-   ///FIXME
-//   this->targetIterator++;
-   PNode* retNode = dynamic_cast<PNode*>((*targetIterator));
-//   if (retNode == NULL && this->targetIterator->getList()->getSize() > 0)
-//     retNode =  dynamic_cast<PNode*>(targetIterator->firstElement());
-
-   return retNode;
-}
-
-
-/**
- * Selects an Entity from the Entity-List, that is near of the carrier PNode.
- * @param carrier: The PNode from which the distance should be measured
- * @param distance: The Maximum Distance to Return.
- */
-PNode* WeaponManager::getDistanceTarget(const PNode* carrier, float distance)
-{
-  std::list<BaseObject*>* npcList = ClassList::getList(CL_NPC);
-  if (npcList != NULL)
-  {
-    list<BaseObject*>::iterator node;
-    for (node= npcList->begin(); node != npcList->end(); node++)
-      if ((carrier->getAbsCoor() - dynamic_cast<PNode*>(*node)->getAbsCoor()).len() < distance)
-        return dynamic_cast<PNode*>(*node);
-  }
-  return this->getFixedTarget();
 }
 
Index: trunk/src/world_entities/weapons/weapon_manager.h
===================================================================
--- trunk/src/world_entities/weapons/weapon_manager.h	(revision 5866)
+++ trunk/src/world_entities/weapons/weapon_manager.h	(revision 5885)
@@ -80,6 +80,4 @@
     /** @returns a fixed target namely the Crosshair's 3D position */
     inline PNode* getFixedTarget() const { return this->crosshair; };
-    PNode* getSomeTarget();
-    PNode* getDistanceTarget(const PNode* carrier, float distance);
 
     void fire();
@@ -109,5 +107,3 @@
     Crosshair*              crosshair;                                //!< an aim.
     tAnimation<Crosshair>*  crossHairSizeAnim;                        //!< An animation for the crosshair (scaling)
-
-    std::list<BaseObject*>::iterator  targetIterator;                           //!< An iterator for traversion lists of enemies.
 };