Index: /code/branches/core5/src/modules/pong/PongBall.cc
===================================================================
--- /code/branches/core5/src/modules/pong/PongBall.cc	(revision 5891)
+++ /code/branches/core5/src/modules/pong/PongBall.cc	(revision 5892)
@@ -33,5 +33,4 @@
 #include "gametypes/Gametype.h"
 #include "PongBat.h"
-#include "sound/SoundBase.h"
 
 namespace orxonox
@@ -43,7 +42,4 @@
     PongBall::PongBall(BaseObject* creator)
         : MovableEntity(creator)
-        , sidesound_(NULL)
-        , batsound_(NULL)
-        , scoresound_(NULL)
     {
         RegisterObject(PongBall);
@@ -57,26 +53,8 @@
 
         this->registerVariables();
-
-        if (GameMode::playsSound())
-        {
-            this->sidesound_ = new SoundBase(this);
-            this->sidesound_->loadFile("sounds/pong_side.wav");
-
-            this->batsound_ = new SoundBase(this);
-            this->batsound_->loadFile("sounds/pong_bat.wav");
-
-            this->scoresound_ = new SoundBase(this);
-            this->scoresound_->loadFile("sounds/pong_score.wav");
-        }
     }
 
     PongBall::~PongBall()
     {
-        if (this->sidesound_)
-            delete this->sidesound_;
-        if (this->batsound_)
-            delete this->batsound_;
-        if (this->scoresound_)
-            delete this->scoresound_;
     }
 
@@ -108,6 +86,4 @@
 
             this->fireEvent();
-            if (GameMode::playsSound())
-                this->sidesound_->play();
         }
 
@@ -128,6 +104,4 @@
                         
                         this->fireEvent();
-                        if (GameMode::playsSound())
-                            this->batsound_->play();
                     }
                     else if (GameMode::isMaster() && position.x > this->fieldWidth_ / 2 * (1 + this->relMercyOffset_))
@@ -136,6 +110,4 @@
                         {
                             this->getGametype()->playerScored(this->bat_[0]->getPlayer());
-                            if (GameMode::playsSound())
-                                this->scoresound_->play();
                             return;
                         }
@@ -152,6 +124,4 @@
 
                         this->fireEvent();
-                        if (GameMode::playsSound())
-                            this->batsound_->play();
                     }
                     else if (GameMode::isMaster() && position.x < -this->fieldWidth_ / 2 * (1 + this->relMercyOffset_))
@@ -159,6 +129,4 @@
                         if (this->getGametype() && this->bat_[1])
                         {
-                            if (GameMode::playsSound())
-                                this->scoresound_->play();
                             this->getGametype()->playerScored(this->bat_[1]->getPlayer());
                             return;
Index: /code/branches/core5/src/modules/pong/PongBall.h
===================================================================
--- /code/branches/core5/src/modules/pong/PongBall.h	(revision 5891)
+++ /code/branches/core5/src/modules/pong/PongBall.h	(revision 5892)
@@ -76,8 +76,4 @@
             unsigned int* batID_;
             float relMercyOffset_;
-
-            SoundBase* sidesound_;
-            SoundBase* batsound_;
-            SoundBase* scoresound_;
     };
 }
Index: /code/branches/core5/src/orxonox/Level.cc
===================================================================
--- /code/branches/core5/src/orxonox/Level.cc	(revision 5891)
+++ /code/branches/core5/src/orxonox/Level.cc	(revision 5892)
@@ -39,5 +39,4 @@
 #include "gametypes/Gametype.h"
 #include "overlays/OverlayGroup.h"
-#include "sound/SoundBase.h"
 #include "LevelManager.h"
 
@@ -53,5 +52,4 @@
         this->xmlfilename_ = this->getFilename();
         this->xmlfile_ = 0;
-        this->ambientsound_ = 0;
     }
 
@@ -65,7 +63,4 @@
             if (this->xmlfile_)
                 Loader::unload(this->xmlfile_);
-
-            if (this->ambientsound_ != NULL)
-                delete this->ambientsound_;
         }
     }
@@ -77,6 +72,4 @@
         XMLPortParam(Level, "description", setDescription, getDescription, xmlelement, mode);
         XMLPortParam(Level, "gametype", setGametypeString, getGametypeString, xmlelement, mode).defaultValues("Gametype");
-
-        XMLPortParamLoadOnly(Level, "ambientsound", loadAmbientSound, xmlelement, mode);
 
         XMLPortObjectExtended(Level, BaseObject, "", addObject, getObject, xmlelement, mode, true, false);
@@ -150,19 +143,4 @@
     }
 
-    void Level::loadAmbientSound(const std::string& filename)
-    {
-        if(filename == "") return;
-        else
-        {
-            if(this->ambientsound_ == NULL)
-            {
-                this->ambientsound_ = new SoundBase();
-            }
-
-            this->ambientsound_->loadFile(filename);
-            this->ambientsound_->play(true);
-        }
-    }
-
     void Level::playerEntered(PlayerInfo* player)
     {
Index: /code/branches/core5/src/orxonox/Level.h
===================================================================
--- /code/branches/core5/src/orxonox/Level.h	(revision 5891)
+++ /code/branches/core5/src/orxonox/Level.h	(revision 5892)
@@ -53,6 +53,4 @@
                 { return this->description_; }
 
-            void loadAmbientSound(const std::string& filename);
-
             void playerEntered(PlayerInfo* player);
             void playerLeft(PlayerInfo* player);
@@ -73,6 +71,4 @@
             XMLFile*               xmlfile_;
             std::list<BaseObject*> objects_;
-
-            SoundBase*             ambientsound_;
     };
 }
Index: /code/branches/core5/src/orxonox/gamestates/GSMainMenu.cc
===================================================================
--- /code/branches/core5/src/orxonox/gamestates/GSMainMenu.cc	(revision 5891)
+++ /code/branches/core5/src/orxonox/gamestates/GSMainMenu.cc	(revision 5892)
@@ -39,5 +39,5 @@
 #include "core/GUIManager.h"
 #include "Scene.h"
-#include "sound/SoundMainMenu.h"
+#include "sound/SoundBase.h"
 
 namespace orxonox
@@ -62,5 +62,6 @@
         {
             // Load sound
-            this->ambient_ = new SoundMainMenu();
+            this->ambient_ = new SoundBase(0);
+            this->ambient_->loadFile("ambient/mainmenu.wav");
         }
     }
@@ -69,7 +70,5 @@
     {
         if (GameMode::playsSound())
-        {
-            this->ambient_->destroy();
-        }
+            delete this->ambient_;
 
         InputManager::getInstance().destroyState("mainMenu");
Index: /code/branches/core5/src/orxonox/gamestates/GSMainMenu.h
===================================================================
--- /code/branches/core5/src/orxonox/gamestates/GSMainMenu.h	(revision 5891)
+++ /code/branches/core5/src/orxonox/gamestates/GSMainMenu.h	(revision 5892)
@@ -59,5 +59,5 @@
 
         // ambient sound for the main menu
-        SoundMainMenu* ambient_;
+        SoundBase*        ambient_;
     };
 }
Index: /code/branches/core5/src/orxonox/items/Engine.cc
===================================================================
--- /code/branches/core5/src/orxonox/items/Engine.cc	(revision 5891)
+++ /code/branches/core5/src/orxonox/items/Engine.cc	(revision 5892)
@@ -37,5 +37,4 @@
 #include "pickup/ModifierType.h"
 #include "tools/Shader.h"
-#include "sound/SoundBase.h"
 
 namespace orxonox
@@ -68,6 +67,4 @@
         this->setConfigValues();
         this->registerVariables();
-
-        this->sound_ = NULL;
     }
 
@@ -80,7 +77,4 @@
             if (this->boostBlur_)
                 this->boostBlur_->destroy();
-
-            if(this->sound_ != NULL)
-                delete this->sound_;
         }
     }
@@ -102,6 +96,4 @@
         XMLPortParam(Engine, "accelerationleftright", setAccelerationLeftRight, setAccelerationLeftRight, xmlelement, mode);
         XMLPortParam(Engine, "accelerationupdown",    setAccelerationUpDown,    setAccelerationUpDown,    xmlelement, mode);
-
-        XMLPortParamLoadOnly(Engine, "sound", loadSound, xmlelement, mode);
     }
 
@@ -240,7 +232,4 @@
                 this->boostBlur_ = 0;
             }
-
-            if(this->sound_ != NULL)
-                this->sound_->attachToEntity(ship);
         }
     }
@@ -253,18 +242,3 @@
             return Vector3::ZERO;
     }
-
-    void Engine::loadSound(const std::string filename)
-    {
-        if(filename == "") return;
-        else
-        {
-            if(this->sound_ == NULL)
-            {
-                this->sound_ = new SoundBase(this->ship_);
-            }
-
-            this->sound_->loadFile(filename);
-            this->sound_->play(true);
-        }
-    }
 }
Index: /code/branches/core5/src/orxonox/items/Engine.h
===================================================================
--- /code/branches/core5/src/orxonox/items/Engine.h	(revision 5891)
+++ /code/branches/core5/src/orxonox/items/Engine.h	(revision 5892)
@@ -130,6 +130,4 @@
             Shader* boostBlur_;
             float blurStrength_;
-
-            SoundBase* sound_;
     };
 }
Index: /code/branches/core5/src/orxonox/sound/CMakeLists.txt
===================================================================
--- /code/branches/core5/src/orxonox/sound/CMakeLists.txt	(revision 5891)
+++ /code/branches/core5/src/orxonox/sound/CMakeLists.txt	(revision 5892)
@@ -2,5 +2,4 @@
     SoundManager.cc
     SoundBase.cc
-    SoundMainMenu.cc
 )
 
Index: de/branches/core5/src/orxonox/sound/SoundMainMenu.cc
===================================================================
--- /code/branches/core5/src/orxonox/sound/SoundMainMenu.cc	(revision 5891)
+++ 	(revision )
@@ -1,47 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *                    > www.orxonox.net <
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *       Erwin 'vaiursch' Herrsche
- *   Co-authors:
- *      ...
- *
- */
-
-#include "SoundMainMenu.h"
-
-#include "core/CoreIncludes.h"
-#include "core/ConfigValueIncludes.h"
-
-namespace orxonox
-{
-    SoundMainMenu::SoundMainMenu()
-    {
-        RegisterObject(SoundMainMenu);
-        setConfigValues();
-        loadFile(this->filename_);
-    }
-
-    void SoundMainMenu::setConfigValues()
-    {
-        SetConfigValue(filename_, "ambient/mainmenu.wav");
-    }
-}
Index: de/branches/core5/src/orxonox/sound/SoundMainMenu.h
===================================================================
--- /code/branches/core5/src/orxonox/sound/SoundMainMenu.h	(revision 5891)
+++ 	(revision )
@@ -1,51 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *                    > www.orxonox.net <
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *       Erwin 'vaiursch' Herrsche
- *   Co-authors:
- *      ...
- *
- */
-
-#ifndef _SoundMainMenu_H__
-#define _SoundMainMenu_H__
-
-#include "OrxonoxPrereqs.h"
-
-#include <string>
-#include "core/OrxonoxClass.h"
-#include "SoundBase.h"
-
-namespace orxonox
-{
-    class _OrxonoxExport SoundMainMenu : public SoundBase, public virtual OrxonoxClass
-    {
-        public:
-            SoundMainMenu();
-            void setConfigValues();
-
-        private:
-            std::string filename_;
-    };
-}
-
-#endif /* _SoundMainMenu_H__ */