Index: code/branches/core5/src/orxonox/gamestates/GSMainMenu.cc
===================================================================
--- code/branches/core5/src/orxonox/gamestates/GSMainMenu.cc	(revision 5898)
+++ code/branches/core5/src/orxonox/gamestates/GSMainMenu.cc	(revision 5899)
@@ -63,5 +63,5 @@
             // Load sound
             this->ambient_ = new AmbientSound(0);
-            this->ambient_->setSoundFile("ambient/mainmenu.wav");
+            this->ambient_->setSource("ambient/mainmenu.wav");
         }
     }
Index: code/branches/core5/src/orxonox/sound/AmbientSound.cc
===================================================================
--- code/branches/core5/src/orxonox/sound/AmbientSound.cc	(revision 5898)
+++ code/branches/core5/src/orxonox/sound/AmbientSound.cc	(revision 5899)
@@ -49,5 +49,5 @@
     {
         SUPER(AmbientSound, XMLPort, xmlelement, mode);
-        XMLPortParamExtern(AmbientSound, BaseSound, this, "soundFile", setSoundFile, getSoundFile, xmlelement, mode);
+        XMLPortParamExtern(AmbientSound, BaseSound, this, "source", setSource, getSource, xmlelement, mode);
         XMLPortParamExtern(AmbientSound, BaseSound, this, "loop", setLoop, getLoop, xmlelement, mode);
         XMLPortParamExtern(AmbientSound, BaseSound, this, "playOnLoad", setPlayOnLoad, getPlayOnLoad, xmlelement, mode);
Index: code/branches/core5/src/orxonox/sound/BaseSound.cc
===================================================================
--- code/branches/core5/src/orxonox/sound/BaseSound.cc	(revision 5898)
+++ code/branches/core5/src/orxonox/sound/BaseSound.cc	(revision 5899)
@@ -40,6 +40,6 @@
 {
     BaseSound::BaseSound()
-        : source_(0)
-        , buffer_(0)
+        : audioSource_(0)
+        , audioBuffer_(0)
         , bPlayOnLoad_(false)
         , bLoop_(false)
@@ -50,20 +50,20 @@
     BaseSound::~BaseSound()
     {
-        this->setSoundFile("");
+        this->setSource("");
     }
 
     void BaseSound::play()
     {
-        if (alIsSource(this->source_))
+        if (alIsSource(this->audioSource_))
         {
             if (this->bLoop_)
-                alSourcei(this->source_, AL_LOOPING, AL_TRUE);
+                alSourcei(this->audioSource_, AL_LOOPING, AL_TRUE);
             else
-                alSourcei(this->source_, AL_LOOPING, AL_FALSE);
-            alSourcePlay(this->source_);
+                alSourcei(this->audioSource_, AL_LOOPING, AL_FALSE);
+            alSourcePlay(this->audioSource_);
 
             if (alGetError() != AL_NO_ERROR)
             {
-                 COUT(2) << "Sound: OpenAL: Error playin sound " << this->source_ << std::endl;
+                 COUT(2) << "Sound: OpenAL: Error playin sound " << this->audioSource_ << std::endl;
             }
         }
@@ -72,17 +72,17 @@
     void BaseSound::stop()
     {
-        if (alIsSource(this->source_))
-            alSourceStop(this->source_);
+        if (alIsSource(this->audioSource_))
+            alSourceStop(this->audioSource_);
     }
 
     void BaseSound::pause()
     {
-        if (alIsSource(this->source_))
-            alSourcePause(this->source_);
+        if (alIsSource(this->audioSource_))
+            alSourcePause(this->audioSource_);
     }
 
     bool BaseSound::isPlaying()
     {
-        if (alIsSource(this->source_))
+        if (alIsSource(this->audioSource_))
             return getSourceState() == AL_PLAYING;
         return false;
@@ -91,5 +91,5 @@
     bool BaseSound::isPaused()
     {
-        if (alIsSource(this->source_))
+        if (alIsSource(this->audioSource_))
             return getSourceState() == AL_PAUSED;
         return true;
@@ -98,5 +98,5 @@
     bool BaseSound::isStopped()
     {
-        if (alIsSource(this->source_))
+        if (alIsSource(this->audioSource_))
             return getSourceState() == AL_INITIAL || getSourceState() == AL_STOPPED;
         return true;
@@ -109,36 +109,36 @@
     }
 
-    void BaseSound::setSoundFile(const std::string& soundFile)
-    {
-        this->soundFile_ = soundFile;
+    void BaseSound::setSource(const std::string& source)
+    {
+        this->source_ = source;
         if (!GameMode::playsSound())
             return;
 
-        if (soundFile.empty() && alIsSource(this->source_))
+        if (source.empty() && alIsSource(this->audioSource_))
         {
             // Unload sound
-            alSourcei(this->source_, AL_BUFFER, 0);
-            alDeleteSources(1, &this->source_);
-            alDeleteBuffers(1, &this->buffer_);
-            return;
-        }
-
-        COUT(3) << "Sound: OpenAL ALUT: loading file " << soundFile << std::endl;
+            alSourcei(this->audioSource_, AL_BUFFER, 0);
+            alDeleteSources(1, &this->audioSource_);
+            alDeleteBuffers(1, &this->audioBuffer_);
+            return;
+        }
+
+        COUT(3) << "Sound: OpenAL ALUT: loading file " << source << std::endl;
         // Get DataStream from the resources
-        shared_ptr<ResourceInfo> fileInfo = Resource::getInfo(soundFile);
+        shared_ptr<ResourceInfo> fileInfo = Resource::getInfo(source);
         if (fileInfo == NULL)
         {
-            COUT(2) << "Warning: Sound file '" << soundFile << "' not found" << std::endl;
-            return;
-        }
-        DataStreamPtr stream = Resource::open(soundFile);
+            COUT(2) << "Warning: Sound file '" << source << "' not found" << std::endl;
+            return;
+        }
+        DataStreamPtr stream = Resource::open(source);
         // Read everything into a temporary buffer
         char* buffer = new char[fileInfo->size];
         stream->read(buffer, fileInfo->size);
 
-        this->buffer_ = alutCreateBufferFromFileImage(buffer, fileInfo->size);
+        this->audioBuffer_ = alutCreateBufferFromFileImage(buffer, fileInfo->size);
         delete[] buffer;
 
-        if (this->buffer_ == AL_NONE)
+        if (this->audioBuffer_ == AL_NONE)
         {
             COUT(2) << "Sound: OpenAL ALUT: " << alutGetErrorString(alutGetError()) << std::endl;
@@ -147,8 +147,8 @@
             //{
             //    COUT(2) << "Sound: Trying fallback ogg loader" << std::endl;
-            //    this->buffer_ = loadOggFile(filename);
+            //    this->audioBuffer_ = loadOggFile(filename);
             //}
 
-            //if (this->buffer_ == AL_NONE)
+            //if (this->audioBuffer_ == AL_NONE)
             //{
             //    COUT(2) << "Sound: fallback ogg loader failed: " << alutGetErrorString(alutGetError()) << std::endl;
@@ -157,13 +157,13 @@
         }
 
-        alGenSources(1, &this->source_);
-        alSourcei(this->source_, AL_BUFFER, this->buffer_);
+        alGenSources(1, &this->audioSource_);
+        alSourcei(this->audioSource_, AL_BUFFER, this->audioBuffer_);
         if (alGetError() != AL_NO_ERROR)
         {
-            COUT(2) << "Sound: OpenAL: Error loading sample file: " << soundFile << std::endl;
-            return;
-        }
-
-        alSource3f(this->source_, AL_POSITION,  0, 0, 0);
+            COUT(2) << "Sound: OpenAL: Error loading sample file: " << source << std::endl;
+            return;
+        }
+
+        alSource3f(this->audioSource_, AL_POSITION,  0, 0, 0);
 
         if (this->bPlayOnLoad_)
@@ -174,5 +174,5 @@
     {
         ALint state;
-        alGetSourcei(this->source_, AL_SOURCE_STATE, &state);
+        alGetSourcei(this->audioSource_, AL_SOURCE_STATE, &state);
         return state;
     }
Index: code/branches/core5/src/orxonox/sound/BaseSound.h
===================================================================
--- code/branches/core5/src/orxonox/sound/BaseSound.h	(revision 5898)
+++ code/branches/core5/src/orxonox/sound/BaseSound.h	(revision 5899)
@@ -55,6 +55,6 @@
         bool isStopped();
 
-        void setSoundFile(const std::string& soundFile);
-        const std::string& getSoundFile() { return this->soundFile_; }
+        void setSource(const std::string& source);
+        const std::string& getSource() { return this->source_; }
 
         bool getPlayOnLoad() { return this->bPlayOnLoad_; }
@@ -65,12 +65,12 @@
 
     protected:
-        //ALuint loadOggFile(const std::string& filename);
+        ALuint loadOggFile(const std::string& filename);
         ALint getSourceState();
 
-        ALuint source_;
-        ALuint buffer_;
+        ALuint audioSource_;
+        ALuint audioBuffer_;
 
     private:
-        std::string soundFile_;
+        std::string source_;
         bool bPlayOnLoad_;
         bool bLoop_;
Index: code/branches/core5/src/orxonox/sound/WorldSound.cc
===================================================================
--- code/branches/core5/src/orxonox/sound/WorldSound.cc	(revision 5898)
+++ code/branches/core5/src/orxonox/sound/WorldSound.cc	(revision 5899)
@@ -52,5 +52,5 @@
     {
         SUPER(WorldSound, XMLPort, xmlelement, mode);
-        XMLPortParamExtern(WorldSound, BaseSound, this, "soundFile", setSoundFile, getSoundFile, xmlelement, mode);
+        XMLPortParamExtern(WorldSound, BaseSound, this, "source", setSource, getSource, xmlelement, mode);
         XMLPortParamExtern(WorldSound, BaseSound, this, "loop", setLoop, getLoop, xmlelement, mode);
         XMLPortParamExtern(WorldSound, BaseSound, this, "playOnLoad", setPlayOnLoad, getPlayOnLoad, xmlelement, mode);
@@ -65,8 +65,8 @@
     void WorldSound::tick(float dt)
     {
-        if (alIsSource(this->source_))
+        if (alIsSource(this->audioSource_))
         {
             const Vector3& pos = this->getWorldPosition();
-            alSource3f(this->source_, AL_POSITION, pos.x, pos.y, pos.z);
+            alSource3f(this->audioSource_, AL_POSITION, pos.x, pos.y, pos.z);
             ALenum error = alGetError();
             if (error == AL_INVALID_VALUE)
@@ -74,5 +74,5 @@
 
             const Vector3& vel = this->getVelocity();
-            alSource3f(this->source_, AL_VELOCITY, vel.x, vel.y, vel.z);
+            alSource3f(this->audioSource_, AL_VELOCITY, vel.x, vel.y, vel.z);
             error = alGetError();
             if (error == AL_INVALID_VALUE)
@@ -81,5 +81,5 @@
             const Quaternion& orient = this->getWorldOrientation();
             Vector3 at = orient.zAxis();
-            alSource3f(this->source_, AL_DIRECTION, at.x, at.y, at.z);
+            alSource3f(this->audioSource_, AL_DIRECTION, at.x, at.y, at.z);
             error = alGetError();
             if (error == AL_INVALID_VALUE)